/*
 * Sequence
 * The CSS3 Animation Framework
 *
 * @link https://github.com/IanLunn/Sequence
 * @author IanLunn
 * @version 2.0.0-alpha.1
 * @license https://github.com/IanLunn/Sequence/blob/master/LICENSE
 * @copyright IanLunn
 */
function defineSequence(imagesLoaded,Hammer){"use strict";var Sequence=function(element,options){function isArray(object){return"[object Array]"===Object.prototype.toString.call(object)?!0:!1}function extend(a,b){for(var i in b)a[i]=b[i];return a}function addEvent(obj,type,fn){return obj.attachEvent===!0?(obj["e"+type+fn]=fn,obj[type+fn]=function(){obj["e"+type+fn](window.event)},obj.attachEvent("on"+type,obj[type+fn])):obj.addEventListener(type,fn,!1),fn}function removeEvent(obj,type,fn){obj.detachEvent===!0?(obj.detachEvent("on"+type,obj[type+fn]),obj[type+fn]=null):obj.removeEventListener(type,fn,!1)}function getElementsByClassName(node,classname){return node.getElementsByClassName===!0?node.getElementsByClassName(classname):function(searchClass,node){null===node&&(node=document);var i,j,classElements=[],els=node.getElementsByTagName("*"),elsLen=els.length,pattern=new RegExp("(^|\\s)"+searchClass+"(\\s|$)");for(i=0,j=0;elsLen>i;i++)pattern.test(els[i].className)&&(classElements[j]=els[i],j++);return classElements}(classname,node)}function convertTimeToMs(time){var convertedTime,fraction;return fraction=time.indexOf("ms")>-1?1:1e3,convertedTime="0s"==time?0:parseFloat(time.replace("s",""))*fraction}function hasClass(el,name){return new RegExp("(\\s|^)"+name+"(\\s|$)").test(el.className)}function addClass(el,name){!hasClass(el,name)==!0&&(el.className+=(el.className?" ":"")+name)}function removeClass(el,name){hasClass(el,name)===!0&&(el.className=el.className.replace(new RegExp("(\\s|^)"+name+"(\\s|$)")," ").replace(/^\s+|\s+$/g,""))}function removeNoJsClass(self){if(self.transitionsSupported!==!1)for(var i=0;i<self.steps.length;i++){var element=self.steps[i];if(hasClass(element,"animate-in")===!0){var step="step"+(i+1);self._animation.resetInheritedSpeed(step,"animate-in"),removeClass(element,"animate-in")}}}function getPaginationIndex(paginationElement,target,previousTarget){if("body"!==target.localName){if(paginationElement!==target){var previousTarget=target;return getPaginationIndex(paginationElement,target.parentNode,previousTarget)}if(void 0!==previousTarget)for(var topLevel=previousTarget,allTopLevel=paginationElement.getElementsByTagName(topLevel.localName),i=allTopLevel.length;i--;)if(topLevel===allTopLevel[i])return i+1}}function getSteps(parent){for(var steps=[],elements=parent.getElementsByTagName("*"),elementsLength=elements.length,i=0;elementsLength>i;i++){var element=elements[i],parent=element.parentNode;hasClass(parent,"sequence-canvas")===!0&&steps.push(element)}return steps}function propertiesToCss(properties,polar){var css="";return css+="translateX("+properties.sequenceX+"px) ",css+="translateY("+properties.sequenceY+"px) ",css+="translateZ("+properties.sequenceZ+"px) ",polar!==!0?(css+="rotateX("+properties.sequenceRotateX+"deg) ",css+="rotateY("+properties.sequenceRotateY+"deg) ",css+="rotateZ("+properties.sequenceRotate+"deg) ",css+="scale("+properties.sequenceScale+")"):(css+="rotateZ("+properties.sequenceRotate+"deg) ",css+="rotateY("+properties.sequenceRotateY+"deg) ",css+="rotateX("+properties.sequenceRotateX+"deg) "),css}if("true"!==element.dataset.sequence){element.dataset.sequence=!0;var defaults={startingStepId:1,startingStepAnimatesIn:!1,cycle:!0,phaseThreshold:!0,reverseWhenNavigatingBackwards:!1,moveActiveStepToTop:!0,animateCanvas:!0,animateCanvasDuration:500,autoPlay:!0,autoPlayThreshold:5e3,autoPlayDirection:1,navigationSkip:!0,navigationSkipThreshold:250,fadeStepWhenSkipped:!1,fadeStepTime:500,preventReverseSkipping:!1,nextButton:!0,prevButton:!0,pauseButton:!0,unpauseThreshold:null,pauseOnHover:!0,pagination:!0,preloader:!1,preloadTheseSteps:[1],preloadTheseImages:[],hideStepsUntilPreloaded:!0,keyNavigation:!0,numericKeysGoToSteps:!0,keyEvents:{left:function(sequence){sequence.prev()},right:function(sequence){sequence.next()}},swipeNavigation:!0,swipeEvents:{left:function(sequence){sequence.prev()},right:function(sequence){sequence.next()},up:!1,down:!1},swipeHammerOptions:{prevent_mouseevents:!0,drag_min_distance:10,stop_browser_behavior:!1},hashTags:!1,hashDataAttribute:!1,hashChangesOnFirstStep:!1,fallback:{speed:500,layout:"auto"}},domThreshold=50,resizeThreshold=100,Modernizr=function(a,b,c){function x(a){i.cssText=a}function z(a,b){return typeof a===b}function A(a,b){return!!~(""+a).indexOf(b)}function B(a,b){for(var d in a){var e=a[d];if(!A(e,"-")&&i[e]!==c)return"pfx"==b?e:!0}return!1}function C(a,b,d){for(var e in a){var f=b[a[e]];if(f!==c)return d===!1?a[e]:z(f,"function")?f.bind(d||b):f}return!1}function D(a,b,c){var d=a.charAt(0).toUpperCase()+a.slice(1),e=(a+" "+m.join(d+" ")+d).split(" ");return z(b,"string")||z(b,"undefined")?B(e,b):(e=(a+" "+n.join(d+" ")+d).split(" "),C(e,b,c))}var j,u,w,d="2.8.2",e={},f=b.documentElement,g="modernizr",h=b.createElement(g),i=h.style,l=({}.toString,"Webkit Moz O ms"),m=l.split(" "),n=l.toLowerCase().split(" "),o={svg:"http://www.w3.org/2000/svg"},p={},s=[],t=s.slice,v={}.hasOwnProperty;w=z(v,"undefined")||z(v.call,"undefined")?function(a,b){return b in a&&z(a.constructor.prototype[b],"undefined")}:function(a,b){return v.call(a,b)},Function.prototype.bind||(Function.prototype.bind=function(b){var c=this;if("function"!=typeof c)throw new TypeError;var d=t.call(arguments,1),e=function(){if(this instanceof e){var a=function(){};a.prototype=c.prototype;var f=new a,g=c.apply(f,d.concat(t.call(arguments)));return Object(g)===g?g:f}return c.apply(b,d.concat(t.call(arguments)))};return e}),p.cssanimations=function(){return D("animationName")},p.csstransitions=function(){return D("transition")},p.svg=function(){return!!b.createElementNS&&!!b.createElementNS(o.svg,"svg").createSVGRect};for(var E in p)w(p,E)&&(u=E.toLowerCase(),e[u]=p[E](),s.push((e[u]?"":"no-")+u));return e.addTest=function(a,b){if("object"==typeof a)for(var d in a)w(a,d)&&e.addTest(d,a[d]);else{if(a=a.toLowerCase(),e[a]!==c)return e;b="function"==typeof b?b():b,"undefined"!=typeof enableClasses&&enableClasses&&(f.className+=" "+(b?"":"no-")+a),e[a]=b}return e},x(""),h=j=null,e._version=d,e._domPrefixes=n,e._cssomPrefixes=m,e.testProp=function(a){return B([a])},e.testAllProps=D,e.prefixed=function(a,b,c){return b?D(a,b,c):D(a,"pfx")},e}(this,window.document),transformOrigin=Modernizr.prefixed("transformOrigin").replace("mO","m-o"),self={};return self._getAnimationMap={init:function(element){if(this.animationMap={},self.transitionsSupported===!0)this.clonedSequence=this.createClone(element),this.clonedCanvas=getElementsByClassName(this.clonedSequence,"sequence-canvas")[0],this.clonedSteps=getSteps(this.clonedCanvas),this.originalClasses=this.clonedSequence.className,this.animationMap.stepsAnimating=0,this.steps(),this.destroyClone(this.clonedSequence);else for(var i=0;i<self.noOfSteps;i++){var step="step"+(i+1);this.animationMap[step]={},this.animationMap[step].element=self.steps[i]}return this.animationMap},getTransformProperties:function(stepName,step){var attribute,attributeReversed,property,origins,stepProperties=step.dataset,originX=0,originY=0,originZ=0,stepTransform={sequenceX:0,sequenceY:0,sequenceZ:0,sequenceRotateX:0,sequenceRotateY:0,sequenceRotate:0,sequenceScale:1},canvasTransform={sequenceX:0,sequenceY:0,sequenceZ:0,sequenceRotateX:0,sequenceRotateY:0,sequenceRotate:0,sequenceScale:1},styles=getComputedStyle(step,null);for(property in stepProperties)if(stepProperties.hasOwnProperty(property)===!0){var attribute=stepProperties[property];if(stepTransform[property]=attribute,"sequenceScale"!==property)var attributeReversed=-1*attribute;else var attributeReversed=1/attribute;canvasTransform[property]=attributeReversed}canvasTransform.sequenceX+=-1*step.offsetLeft,canvasTransform.sequenceY+=-1*step.offsetTop,origins=styles[Modernizr.prefixed("transformOrigin")].split(" "),originX=parseFloat(origins[0]),originY=parseFloat(origins[1]),void 0!==origins[2]&&(originZ=parseFloat(origins[2])),this.animationMap[stepName].transformOrigin={x:originX,y:originY,z:originZ},this.animationMap[stepName].stepTransform=stepTransform,this.animationMap[stepName].canvasTransform=canvasTransform},steps:function(){for(var stepName,clonedStepElement,realStepElement,clonedStepChildren,realStepChildren,noOfStepChildren,transformCss,i=0;i<self.noOfSteps;i++)stepName="step"+(i+1),clonedStepElement=this.clonedSteps[i],realStepElement=self.steps[i],clonedStepChildren=clonedStepElement.getElementsByTagName("*"),realStepChildren=realStepElement.getElementsByTagName("*"),noOfStepChildren=clonedStepChildren.length,this.animationMap[stepName]={},this.animationMap[stepName].element=realStepElement,this.getTransformProperties(stepName,realStepElement),transformCss=propertiesToCss(this.animationMap[stepName].stepTransform),realStepElement.style[Modernizr.prefixed("transform")]=transformCss,realStepElement.style[Modernizr.prefixed("transformStyle")]="preserve-3d",addClass(this.clonedSequence,stepName),this.phases("animate-in",stepName,clonedStepElement,clonedStepChildren,realStepChildren,noOfStepChildren),this.phases("animate-out",stepName,clonedStepElement,clonedStepChildren,realStepChildren,noOfStepChildren),removeClass(this.clonedSequence,stepName)},phases:function(phase,stepName,clonedStepElement,clonedStepChildren,realStepChildren,noOfStepChildren){var element,realElement,styles,elementNo,elements=[],maxDuration=void 0,maxDelay=void 0,maxComputedDuration=void 0,elementProperties={};for(addClass(clonedStepElement,phase),this.animationMap[stepName][phase]={},elementNo=0;noOfStepChildren>elementNo;elementNo++){element=clonedStepChildren[elementNo],realElement=realStepChildren[elementNo],styles=getComputedStyle(element,null)||element.currentStyle,elementProperties={};var transitionDuration=convertTimeToMs(styles[Modernizr.prefixed("transitionDuration")]),transitionDelay=convertTimeToMs(styles[Modernizr.prefixed("transitionDelay")]),transitionTimingFunction=styles[Modernizr.prefixed("transitionTimingFunction")],computedDuration=transitionDuration+transitionDelay;0!==computedDuration&&(elementProperties.element=realElement,elementProperties.duration=transitionDuration,elementProperties.delay=transitionDelay,elementProperties.timingFunction=transitionTimingFunction,elements.push(elementProperties),(void 0===maxDuration||transitionDuration>maxDuration)&&(maxDuration=transitionDuration),(void 0===maxDelay||transitionDelay>maxDelay)&&(maxDelay=transitionDelay),(void 0===maxComputedDuration||computedDuration>maxComputedDuration)&&(maxComputedDuration=computedDuration))}removeClass(clonedStepElement,phase),this.animationMap[stepName][phase].elements=elements,this.animationMap[stepName][phase].noOfElements=elements.length,this.animationMap[stepName][phase].maxDuration=maxDuration,this.animationMap[stepName][phase].maxDelay=maxDelay,this.animationMap[stepName][phase].computedDuration=maxComputedDuration},createClone:function(element){var clonedSequence=element.cloneNode(!0);return clonedSequence.style.display="none",clonedSequence.id="sequence",element.parentNode.insertBefore(clonedSequence,element),clonedSequence},destroyClone:function(element){element.parentNode.removeChild(element)}},self._ui={defaultElements:{nextButton:".sequence-next",prevButton:".sequence-prev",pauseButton:".sequence-pause",pagination:".sequence-pagination",preloader:".sequence-preloader"},getElement:function(type,option){var element;return element=document.querySelectorAll(option===!0?this.defaultElements[type]:option)},show:function(element,duration){self.transitionsSupported===!0&&(element.style[Modernizr.prefixed("transitionDuration")]=duration+"ms",element.style[Modernizr.prefixed("transitionProperty")]="opacity, "+Modernizr.prefixed("transform"),element.style.opacity=1)},hide:function(element,duration,callback){self.transitionsSupported===!0&&(element.style[Modernizr.prefixed("transitionDuration")]=duration+"ms",element.style[Modernizr.prefixed("transitionProperty")]="opacity, "+Modernizr.prefixed("transform"),element.style.opacity=".2"),void 0!==callback&&setTimeout(function(){callback()},duration)}},self._autoPlay={init:function(){self.isAutoPlayActive=!1,self.isPaused=self.options.autoPlay===!0?!1:!0,self.isHardPaused=self.isPaused,self.options.unpauseThreshold=null===self.options.unpauseThreshold?self.options.autoPlayThreshold:self.options.unpauseThreshold,self.options.autoPlay===!0&&self.isPaused===!1&&this.start()},unpause:function(){self.isPaused===!0&&(self.isPaused=!1,this.start(),removeClass(self.container,"paused"),self.unpaused(self))},pause:function(){self.isPaused===!1&&(self.isPaused=!0,this.stop(),addClass(self.container,"paused"),self.paused(self))},start:function(){var threshold;threshold=self.isPaused===!1?self.options.autoPlayThreshold:self.options.unpauseThreshold,self.isAutoPlayActive=!0,self.options.autoPlay=!0,clearTimeout(self.autoPlayTimer),self.autoPlayTimer=setTimeout(function(){1===self.options.autoPlayDirection?self.next():self.prev()},threshold)},stop:function(){self.isAutoPlayActive=!1,self.options.autoPlay=!1,clearTimeout(self.autoPlayTimer)}},self._canvas={getTransformCss:function(id){var transformCss,stepName="step"+id,origin=self.animationMap[stepName].transformOrigin,canvasTransformProperties=self.animationMap[stepName].canvasTransform,originX=(self.animationMap[stepName].stepTransform,origin.x+-1*canvasTransformProperties.sequenceX),originY=origin.y+-1*canvasTransformProperties.sequenceY,originZ=origin.z+-1*canvasTransformProperties.sequenceZ;return transformCss=propertiesToCss(canvasTransformProperties,!0),{origins:originX+"px "+originY+"px "+originZ+"px",string:transformCss,scale:canvasTransformProperties.sequenceScale}},move:function(id,animate){if(self.options.animateCanvas===!0){var transformCss,canvas=self.canvas,duration=0;animate===!0&&self._firstRun===!1&&(duration=self.options.animateCanvasDuration),self.transitionsSupported===!0&&(transformCss=this.getTransformCss(id),self.screen.style[Modernizr.prefixed("transitionDuration")]=duration+"ms",self.screen.style[Modernizr.prefixed("transitionProperty")]=Modernizr.prefixed("transform"),self.screen.style[Modernizr.prefixed("transform")]="scale("+transformCss.scale+")",canvas.style[Modernizr.prefixed("transitionDuration")]=duration+"ms",canvas.style[Modernizr.prefixed("transitionProperty")]=Modernizr.prefixed("transform")+", "+transformOrigin,canvas.style[Modernizr.prefixed("transformOrigin")]=transformCss.origins,canvas.style[Modernizr.prefixed("transform")]=transformCss.string)}}},self._animation={moveActiveStepToTop:function(currentStepElement,nextStepElement){if(self.options.moveActiveStepToTop===!0){var prevStepElement=self.animationMap["step"+self.prevStepId].element;prevStepElement.style.zIndex=1,currentStepElement.style.zIndex=self.noOfSteps-1,nextStepElement.style.zIndex=self.noOfSteps}},manageNavigationSkip:function(id,direction,currentStep,nextStep,nextStepElement){if(self.transitionsSupported!==!1){if(self._ui.show(nextStepElement,0),self.options.navigationSkip===!0){var activeStepsLength=self.animationMap.stepsAnimating;if(self.animationMap[currentStep].isAnimating=!0,self.animationMap[nextStep].isAnimating=!0,self.animationMap.stepsAnimating+=2,0!==activeStepsLength&&(self.navigationSkipThresholdActive=!0,clearTimeout(self.phaseThresholdTimer),self.options.fadeStepWhenSkipped===!0))for(var i=1;i<=self.noOfSteps;i++){var step="step"+i,stepProperties=self.animationMap[step];if(stepProperties.isAnimating===!0&&i!==id){var stepElement=stepProperties.element;self._animation.stepSkipped(direction,step,stepElement)}}setTimeout(function(){self.navigationSkipThresholdActive=!1},self.options.navigationSkipThreshold)}}},stepSkipped:function(direction,step,stepElement){self._ui.hide(stepElement,self.options.fadeStepTime,function(){})},changeStep:function(id){var stepToAdd="step"+id;if(void 0!==self.currentStepId){var stepToRemove="step"+self.currentStepId;addClass(self.container,stepToAdd),removeClass(self.container,stepToRemove)}else addClass(self.container,stepToAdd)},reverseProperties:function(step,phase,stepDurations){for(var _animation=this,stepProperties=self.animationMap[step][phase],i=0;i<stepProperties.noOfElements;i++){var stepElements=stepProperties.elements[i];stepElements.element.style[Modernizr.prefixed("transition")]=stepDurations.animation+"ms "+stepDurations.delay+"ms "+_animation.reverseTimingFunction(stepElements.timingFunction)}setTimeout(function(){for(var i=0;i<stepProperties.noOfElements;i++){var stepElements=stepProperties.elements[i];stepElements.element.style[Modernizr.prefixed("transition")]=""}},stepDurations.total)},forward:function(id,nextStep,nextStepElement,currentStep,currentStepElement,stepDurations,hashTagNav){var _animation=this;removeClass(nextStepElement,"animate-out"),_animation.domDelay(function(){addClass(currentStepElement,"animate-out"),removeClass(currentStepElement,"animate-in"),_animation.startAnimateIn(id,1,nextStep,nextStepElement,currentStep,currentStepElement,stepDurations,hashTagNav)})},reverse:function(id,nextStep,nextStepElement,currentStep,currentStepElement,stepDurations,hashTagNav){var _animation=this;addClass(nextStepElement,"animate-out"),_animation.domDelay(function(){_animation.reverseProperties(currentStep,"animate-out",stepDurations["current-phase"]),_animation.reverseProperties(nextStep,"animate-in",stepDurations["next-phase"]),removeClass(currentStepElement,"animate-in"),_animation.startAnimateIn(id,-1,nextStep,nextStepElement,currentStep,currentStepElement,stepDurations,hashTagNav)})},startAnimateIn:function(id,direction,nextStep,nextStepElement,currentStep,currentStepElement,stepDurations,hashTagNav){var _animation=this,currentPhaseDuration=0,nextPhaseDuration=0,nextPhaseThreshold=0,stepDurationTotal=0;self.prevStepId=self.currentStepId,self.currentStepId=id,self.animationStarted(id,self),_animation._currentPhaseStarted(),self._firstRun===!1?(currentPhaseDuration=stepDurations["current-phase"].total,nextPhaseDuration=stepDurations["next-phase"].total,nextPhaseThreshold=stepDurations["next-phase-threshold"],stepDurationTotal=stepDurations["step-total"],self.phaseThresholdTimer=setTimeout(function(){_animation._nextPhaseStarted(hashTagNav),addClass(nextStepElement,"animate-in"),removeClass(nextStepElement,"animate-out")},nextPhaseThreshold)):(self.options.startingStepAnimatesIn===!1?_animation.resetInheritedSpeed(nextStep,"animate-in"):(nextPhaseDuration=stepDurations["next-phase"].total,stepDurationTotal=nextPhaseDuration),_animation._nextPhaseStarted(hashTagNav),self._firstRun=!1,addClass(nextStepElement,"animate-in"),removeClass(nextStepElement,"animate-out")),_animation.phaseEnded(currentPhaseDuration,currentStep,_animation._currentPhaseEnded),_animation.phaseEnded(nextPhaseDuration,nextStep,_animation._nextPhaseEnded),_animation.stepEnded(id,stepDurationTotal)},_currentPhaseStarted:function(){self.currentPhaseStarted(self)},_currentPhaseEnded:function(){self.currentPhaseEnded(self)},_nextPhaseStarted:function(hashTagNav){void 0===hashTagNav&&self._hashTags.update(),self._pagination.update(),self.nextPhaseStarted(self)},_nextPhaseEnded:function(){self.nextPhaseEnded(self)},phaseEnded:function(stepDurationTotal,step,callback){setTimeout(function(){self.animationMap[step].isAnimating=!1,self.animationMap.stepsAnimating-=1,callback()},stepDurationTotal)},stepEnded:function(id,stepDurationTotal){setTimeout(function(){self._autoPlay.init(),self.isActive=!1,self.animationFinished(id,self)},stepDurationTotal)},getStepDurations:function(nextStepId,nextStep,currentStep,direction){if(self.transitionsSupported!==!1){var durations={};durations["current-phase"]={},durations["next-phase"]={},durations["current-phase"].animation=0,durations["current-phase"].delay=0,durations["current-phase"].total=0,durations["next-phase"].animation=0,durations["next-phase"].delay=0,durations["next-phase"].total=0,durations["next-phase-threshold"]=0,durations["step-total"]=0;var nextPhaseDuration=0,currentPhaseDuration=0,nextDelay=0,currentDelay=0,phaseThreshold=self.options.phaseThreshold;if(1===direction)currentPhaseDuration=self.animationMap[currentStep]["animate-out"].computedDuration,nextPhaseDuration=self.animationMap[nextStep]["animate-in"].computedDuration;else{if(phaseThreshold!==!0){var reverseThreshold=self.animationMap[currentStep]["animate-in"].maxDuration-self.animationMap[nextStep]["animate-out"].maxDuration;reverseThreshold>0?nextDelay=reverseThreshold:currentDelay=Math.abs(reverseThreshold)}currentPhaseDuration=self.animationMap[currentStep]["animate-in"].maxDuration,nextPhaseDuration=self.animationMap[nextStep]["animate-out"].maxDuration,nextDelay+=self.animationMap[currentStep]["animate-in"].maxDelay,currentDelay+=self.animationMap[nextStep]["animate-out"].maxDelay}var currentPhaseDurationTotal=currentPhaseDuration+currentDelay,nextPhaseDurationTotal=nextPhaseDuration+nextDelay;switch(durations["current-phase"].animation=currentPhaseDuration,durations["current-phase"].delay=currentDelay,durations["current-phase"].total=currentPhaseDurationTotal,durations["next-phase"].animation=nextPhaseDuration,durations["next-phase"].delay=nextDelay,phaseThreshold){case!1:durations["next-phase"].total=nextPhaseDurationTotal,durations["step-total"]=currentPhaseDurationTotal>nextPhaseDurationTotal?currentPhaseDurationTotal:nextPhaseDurationTotal;break;case!0:durations["next-phase-threshold"]=currentPhaseDurationTotal,durations["next-phase"].total=currentPhaseDurationTotal+nextPhaseDurationTotal,durations["step-total"]=currentPhaseDurationTotal+nextPhaseDurationTotal;break;default:durations["next-phase-threshold"]=phaseThreshold;var nextPhaseDurationIncThreshold=nextPhaseDurationTotal+phaseThreshold;durations["next-phase"].total=nextPhaseDurationIncThreshold,durations["step-total"]=currentPhaseDurationTotal>nextPhaseDurationIncThreshold?currentPhaseDurationTotal:nextPhaseDurationIncThreshold}return durations}},reversePhase:function(phase){var reversePhase={"animate-out":"animate-in","animate-in":"animate-out"};return reversePhase[phase]},domDelay:function(callback){setTimeout(function(){callback()},domThreshold)},reverseTimingFunction:function(timingFunction){var timingFunctionToCubicBezier={linear:"cubic-bezier(0.0,0.0,1.0,1.0)",ease:"cubic-bezier(0.25, 0.1, 0.25, 1.0)","ease-in":"cubic-bezier(0.42, 0.0, 1.0, 1.0)","ease-in-out":"cubic-bezier(0.42, 0.0, 0.58, 1.0)","ease-out":"cubic-bezier(0.0, 0.0, 0.58, 1.0)"};timingFunction.indexOf("cubic-bezier")<0&&(timingFunction=timingFunctionToCubicBezier[timingFunction]);for(var cubicBezier=timingFunction.replace("cubic-bezier(","").replace(")","").split(","),cubicBezierLength=cubicBezier.length,i=0;cubicBezierLength>i;i++)cubicBezier[i]=parseFloat(cubicBezier[i]);var reversedCubicBezier=[1-cubicBezier[2],1-cubicBezier[3],1-cubicBezier[0],1-cubicBezier[1]];return timingFunction="cubic-bezier("+reversedCubicBezier+")"},getStepProperties:function(step,phase){var stepProperties={};return stepProperties.duration=self.animationMap[step][phase].maxDuration,stepProperties.delay=self.animationMap[step][phase].maxDelay,stepProperties.computedDuration=self.animationMap[step][phase].computedDuration,stepProperties.elements=self.animationMap[step][phase].elements,stepProperties.noOfElements=self.animationMap[step][phase].noOfElements,stepProperties},resetInheritedSpeed:function(step,phase){if(self.transitionsSupported!==!1){for(var stepElements=self.animationMap[step][phase].elements,numberOfStepElements=self.animationMap[step][phase].noOfElements,i=0;numberOfStepElements>i;i++){var stepProperties=stepElements[i];stepProperties.element.style[Modernizr.prefixed("transition")]="0ms 0ms"}setTimeout(function(){for(var i=0;numberOfStepElements>i;i++){var stepProperties=stepElements[i];stepProperties.element.style[Modernizr.prefixed("transition")]=""}},domThreshold)}},getShortestDirection:function(nextId,currentId,noOfSteps){var forwardDirection,reverseDirection,direction;return nextId>currentId?(forwardDirection=nextId-currentId,reverseDirection=currentId+(noOfSteps-nextId)):(reverseDirection=currentId-nextId,forwardDirection=nextId+(noOfSteps-currentId)),direction=reverseDirection>=forwardDirection?1:-1},getDirection:function(id,direction){var _animation=this;return void 0!==direction?direction:(self.options.reverseWhenNavigatingBackwards===!0||self.transitionsSupported===!1?void 0===direction&&self.options.cycle===!0?direction=_animation.getShortestDirection(id,self.currentStepId,self.noOfSteps):void 0===direction&&(direction=id<self.currentStepId?-1:1):direction=1,direction)},propertySupport:function(){self.transitionsSupported=!1,self.animationsSupported=!1,Modernizr.csstransitions===!0&&(self.transitionsSupported=!0),Modernizr.cssanimations===!0&&(self.animationsSupported=!0)}},self._animationFallback={animate:function(element,style,unit,from,to,time,callback){if(element!==!1){var start=(new Date).getTime(),timer=setInterval(function(){var step=Math.min(1,((new Date).getTime()-start)/time);element.style[style]=from+step*(to-from)+unit,1===step&&(void 0!==callback&&callback(),clearInterval(timer))},25);element.style[style]=from+unit}},setupCanvas:function(){if(self.transitionsSupported===!1){addClass(self.container,"sequence-fallback"),self.container.style.overflow="hidden",self.container.style.whiteSpace="nowrap",this.canvasWidth=self.canvas.offsetWidth,self.canvas.style.position="relative",self.canvas.style.width="100%",self.canvas.style.height="100%";for(var i=0;i<self.noOfSteps;i++){var step=self.steps[i];addClass(step,"animate-in"),step.style.width="100%",step.style.height="100%";var layoutOption=self.options.fallback.layout;("auto"===layoutOption&&self.options.animateCanvas===!1||"basic"===layoutOption)&&(step.style.display="inline-block",step.style.position="relative")}}},moveCanvas:function(currentStepElement,nextStepElement,animate){var canvas=self.canvas,currentStepX=currentStepElement.offsetLeft,currentStepY=currentStepElement.offsetTop,nextStepX=nextStepElement.offsetLeft,nextStepY=nextStepElement.offsetTop;animate===!0?(this.animate(canvas,"left","px",-currentStepX,-nextStepX,self.options.fallback.speed),this.animate(canvas,"top","px",-currentStepY,-nextStepY,self.options.fallback.speed)):(canvas.style.left=-nextStepX+"px",canvas.style.top=-nextStepY+"px")},goTo:function(id,currentStep,currentStepElement,nextStep,nextStepElement,direction,hashTagNav){self.prevStepId=self.currentStepId,self.currentStepId=id,void 0===hashTagNav&&self._hashTags.update(),self._firstRun===!1?(this._canvas.move(currentStepElement,nextStepElement,!0),self.animationStarted(self.currentStepId,self)):(this._canvas.move(currentStepElement,nextStepElement),self._firstRun=!1),self._animation.stepEnded(id,self.options.fallback.speed)}},self._pagination={update:function(){if(self.pagination.length>0){void 0!==self.currentPaginationLink&&removeClass(self.currentPaginationLink,"sequence-current");for(var id=self.currentStepId-1,paginationLinks=[],childElements=self.pagination[0].childNodes,childElementsLength=childElements.length,i=0;childElementsLength>i;i++){var child=childElements[i];1===child.nodeType&&paginationLinks.push(child)}self.currentPaginationLink=paginationLinks[id],void 0!==self.currentPaginationLink&&addClass(self.currentPaginationLink,"sequence-current")}}},self._hashTags={init:function(id){if(self.options.hashTags===!0){var correspondingStepId,newHashTag;if(newHashTag=location.hash.replace("#!",""),self.stepHashTags=this.getStepHashTags(),""===newHashTag)return id;self.currentHashTag=newHashTag,correspondingStepId=this.hasCorrespondingStep(),correspondingStepId>-1&&(id=correspondingStepId+1)}return id},hasCorrespondingStep:function(){var correspondingStep=-1,correspondingStepId=self.stepHashTags.indexOf(self.currentHashTag);return correspondingStepId>-1&&(correspondingStep=correspondingStepId),correspondingStep},getStepHashTags:function(){for(var elementHashTag,stepHashTags=[],i=0;i<self.noOfSteps;i++)elementHashTag=self.options.hashDataAttribute===!1?self.steps[i].id:self.steps[i].dataset.sequenceHashtag,stepHashTags.push(elementHashTag);return stepHashTags},update:function(){if(self.options.hashTags===!0&&self._firstRun===!1||self.options.hashTags===!0&&self._firstRun===!0&&self.options.hashChangesOnFirstStep===!0){var hashTagId=self.currentStepId-1;self.currentHashTag=self.stepHashTags[hashTagId],history.pushState?history.pushState(null,null,"#!"+self.currentHashTag):location.hash="#!"+self.currentHashTag}},setupEvent:function(){if("onhashchange"in window)window.addEventListener?(window.addHashChange=function(func,before){window.addEventListener("hashchange",func,before)},window.removeHashChange=function(func){window.removeEventListener("hashchange",func)}):window.attachEvent&&(window.addHashChange=function(func){window.attachEvent("onhashchange",func)},window.removeHashChange=function(func){window.detachEvent("onhashchange",func)});else{var hashChangeFuncs=[],oldHref=location.href;window.addHashChange=function(func,before){"function"==typeof func&&hashChangeFuncs[before?"unshift":"push"](func)},window.removeHashChange=function(func){for(var i=hashChangeFuncs.length-1;i>=0;i--)hashChangeFuncs[i]===func&&hashChangeFuncs.splice(i,1)},setInterval(function(){var newHref=location.href;if(oldHref!==newHref){var _oldHref=oldHref;oldHref=newHref;for(var i=0;i<hashChangeFuncs.length;i++)hashChangeFuncs[i].call(window,{type:"hashchange",newURL:newHref,oldURL:_oldHref})}},100)}}},self._preload={init:function(callback){var _preload=this;if(self.options.preloader!==!1){addClass(self.container,"sequence-preloading"),self.preloader=self._ui.getElement("preloader",self.options.preloader),_preload.append(),_preload.addStyles(),_preload.hideAndShowSteps("hide");var stepImagesToPreload=this.saveImagesToArray(self.options.preloadTheseSteps),individualImagesToPreload=this.saveImagesToArray(self.options.preloadTheseImages,!0),imagesToPreload=stepImagesToPreload.concat(individualImagesToPreload),imgLoad=imagesLoaded(imagesToPreload);imgLoad.on("always",function(){_preload.complete(callback)});var progress=1;imgLoad.on("progress",function(instance,image){var result=image.isLoaded?"loaded":"broken";self.preloadProgress(result,image.img.src,progress++,imagesToPreload.length,self)})}},complete:function(callback){self.preloaded(self),this.hideAndShowSteps("show"),removeClass(self.container,"sequence-preloading"),addClass(self.container,"sequence-preloaded"),this.hide(),callback()},defaultStyles:".sequence-preloader {position: absolute;z-index: 9999;height: 100%;width: 100%;}.sequence-preloader .preload .circle {position: relative;top: -50%;display: inline-block;height: 12px;width: 12px;fill: #ff9442;}.preload {position: relative;top: 50%;display: block;height: 12px;width: 48px;margin: -6px auto 0 auto;}.preload-complete {opacity: 0;visibility: hidden;"+Modernizr.prefixed("transition")+": .5s;}.preload.fallback .circle {float: left;margin-right: 4px;background-color: #ff9442;border-radius: 6px;}",addStyles:function(){if(self.options.preloader===!0){var head=document.head||document.getElementsByTagName("head")[0];if(this.styleElement=document.createElement("style"),this.styleElement.type="text/css",this.styleElement.styleSheet?this.styleElement.styleSheet.cssText=this.defaultStyles:this.styleElement.appendChild(document.createTextNode(this.defaultStyles)),head.appendChild(this.styleElement),Modernizr.svg===!1){var preloadIndicator=self.preloader.firstChild;this.preloadIndicatorTimer=setInterval(function(){self._ui.hide(preloadIndicator,500,function(){self._ui.show(preloadIndicator,500)})},1e3)}}},removeStyles:function(){this.styleElement.parentNode.removeChild(this.styleElement)},saveImagesToArray:function(images,srcOnly){var imagesToPreload=[];if(isArray(images)===!1)return imagesToPreload;var imageLength=images.length;if(srcOnly!==!0)for(var i=0;imageLength>i;i++)for(var step=self.steps[i],imagesInStep=step.getElementsByTagName("img"),imagesInStepLength=imagesInStep.length,j=0;imagesInStepLength>j;j++){var image=imagesInStep[j];imagesToPreload.push(image)}else for(var img=[],i=0;imageLength>i;i++){var src=images[i];
img[i]=new Image,img[i].src=src,imagesToPreload.push(img[i])}return imagesToPreload},hide:function(){var _preload=this;self.transitionsSupported===!0?addClass(self.preloader,"preload-complete"):self._ui.hide(self.preloader,500),clearInterval(this.preloadIndicatorTimer),setTimeout(function(){_preload.remove()},500)},append:function(){self.options.preloader===!0&&0===self.preloader.length&&(self.preloader=document.createElement("div"),self.preloader.className="sequence-preloader",self.preloader=[self.preloader],self.preloader[0].innerHTML=Modernizr.svg===!0?'<svg class="preload" xmlns="http://www.w3.org/2000/svg"><circle class="circle" cx="6" cy="6" r="6" opacity="0"><animate attributeName="opacity" values="0;1;0" dur="1s" repeatCount="indefinite" /></circle><circle class="circle" cx="22" cy="6" r="6" opacity="0"><animate attributeName="opacity" values="0;1;0" dur="1s" begin="150ms" repeatCount="indefinite" /></circle><circle class="circle" cx="38" cy="6" r="6" opacity="0"><animate attributeName="opacity" values="0;1;0" dur="1s" begin="300ms" repeatCount="indefinite" /></circle></svg>':'<div class="preload fallback"><div class="circle"></div><div class="circle"></div><div class="circle"></div></div>',self.container.insertBefore(self.preloader[0],null))},remove:function(){self.preloader[0].parentNode.removeChild(self.preloader[0]),self.options.preloader===!0&&this.removeStyles()},hideAndShowSteps:function(type){if(self.options.hideStepsUntilPreloaded===!0&&0!==self.preloader.length)for(var i=0;i<self.noOfSteps;i++){var step=self.steps[i];"hide"===type?self._ui.hide(step,0):self._ui.show(step,0)}}},self.manageEvent={list:{load:[],click:[],mousemove:[],mouseleave:[],Hammer:[],keydown:[],hashchange:[],resize:[]},init:function(){this.add.hashChange(),self.options.swipeNavigation===!0&&this.add.swipeNavigation(),self.options.keyNavigation===!0&&this.add.keyNavigation(),self.options.animateCanvas===!0&&this.add.resizeThrottle(),self.options.nextButton!==!1&&(self.nextButton=self._ui.getElement("nextButton",self.options.nextButton),this.add.button(self.nextButton,self.next)),self.options.prevButton!==!1&&(self.prevButton=self._ui.getElement("prevButton",self.options.prevButton),this.add.button(self.prevButton,self.prev)),self.options.pauseButton!==!1&&(self.pauseButton=self._ui.getElement("pauseButton",self.options.pauseButton),this.add.button(self.pauseButton,self.togglePause)),this.add.pauseOnHover(),self.options.pagination!==!1&&(self.pagination=self._ui.getElement("pagination",self.options.pagination),this.add.pagination(self.pagination))},remove:function(type){var eventElements=self.manageEvent.list[type],eventElementsLength=eventElements.length;switch(type){case"hashchange":removeHashChange(eventElements[0].handler);break;case"Hammer":var handler=self.manageEvent.list.Hammer[0].handler;self.hammerTime.off("dragleft dragright release",handler);break;default:for(var i=0;eventElementsLength>i;i++){var eventProperties=eventElements[i];removeEvent(eventProperties.element,type,eventProperties.handler)}}},add:{hashChange:function(){self._hashTags.setupEvent();var handler=function(e){var newHashTag,id;newHashTag=e.newURL||location.href,newHashTag=newHashTag.split("#!")[1],self.currentHashTag!==newHashTag&&(id=self.stepHashTags.indexOf(newHashTag)+1,self.currentHashTag=newHashTag,self.goTo(id,void 0,void 0,!0))};addHashChange(handler),self.manageEvent.list.hashchange.push({element:window,handler:handler})},button:function(elements,callback){for(var handler,element,elementLength=elements.length,i=0;elementLength>i;i++)element=elements[i],handler=addEvent(element,"click",function(){callback()}),self.manageEvent.list.click.push({element:element,handler:handler})},pagination:function(elements){for(var handler,element,elementLength=elements.length,i=0;elementLength>i;i++)element=elements[i],handler=addEvent(element,"click",function(e){var id=getPaginationIndex(this,e.target);self.goTo(id)}),self.manageEvent.list.click.push({element:element,handler:handler})},pauseOnHover:function(){var handler,insideElement=function(element,cursor){var elementLeft=element.offsetLeft,elementRight=elementLeft+element.clientWidth,elementTop=element.offsetTop,elementBottom=elementTop+element.clientHeight;return cursor.clientX>=elementLeft&&cursor.clientX<=elementRight&&cursor.clientY>=elementTop&&cursor.clientY<=elementBottom?!0:!1},previouslyInside=!1;handler=addEvent(self.container,"mousemove",function(e){insideElement(this,e)===!0?(previouslyInside===!1&&self.options.pauseOnHover===!0&&self._autoPlay.pause(),previouslyInside=!0):(previouslyInside===!0&&self.isHardPaused===!1&&self.options.pauseOnHover===!0&&self._autoPlay.unpause(),previouslyInside=!1)}),self.manageEvent.list.mousemove.push({element:self.container,handler:handler}),handler=addEvent(self.container,"mouseleave",function(){self.isHardPaused===!1&&self.options.pauseOnHover===!0&&self._autoPlay.unpause(),previouslyInside=!1}),self.manageEvent.list.mouseleave.push({element:self.container,handler:handler})},swipeNavigation:function(){var handler=function(e){switch(e.type){case"dragleft":case"dragright":e.gesture.preventDefault();break;case"release":if(Math.abs(e.gesture.deltaX)>=self.hammerTime.options.drag_min_distance||Math.abs(e.gesture.deltaY)>=self.hammerTime.options.drag_min_distance)switch(e.gesture.direction){case"left":self.options.swipeEvents.left(self);break;case"right":self.options.swipeEvents.right(self);break;case"up":self.options.swipeEvents.up!==!1&&self.options.swipeEvents.up(self);break;case"down":self.options.swipeEvents.down!==!1&&self.options.swipeEvents.down(self)}}};self.hammerTime=Hammer(self.container,self.options.swipeHammerOptions).on("dragleft dragright release",handler),self.manageEvent.list.Hammer.push({element:self.container,handler:handler})},keyNavigation:function(){var handler=addEvent(window,"keydown",function(e){var keyCodeChar=parseInt(String.fromCharCode(e.keyCode));switch(keyCodeChar>0&&keyCodeChar<=self.noOfSteps&&self.options.numericKeysGoToSteps&&self.goTo(keyCodeChar),e.keyCode){case 37:self.options.keyEvents.left(self);break;case 39:self.options.keyEvents.right(self)}});self.manageEvent.list.keydown.push({element:window,handler:handler})},resizeThrottle:function(){function throttledEvents(){var i,step,stepName;for(i=0;i<self.noOfSteps;i++)step=self.steps[i],stepName="step"+(i+1),self._getAnimationMap.getTransformProperties(stepName,step);self._canvas.move(self.currentStepId,!1),self.throttledResize(self)}var throttleTimer,handler;handler=addEvent(window,"resize",function(){clearTimeout(throttleTimer),throttleTimer=setTimeout(throttledEvents,resizeThreshold)}),self.manageEvent.list.resize.push({element:window,handler:handler})}}},self._init=function(element){var id,prevStep,prevStepId,goToFirstStep;self.options=extend(defaults,options),self.container=element,self.screen=getElementsByClassName(self.container,"sequence-screen")[0],self.canvas=getElementsByClassName(self.container,"sequence-canvas")[0],self.steps=getSteps(self.canvas),self.containerWidth=self.container.offsetWidth,self.containerHeight=self.container.offsetHeight,self.noOfSteps=self.steps.length,self._animation.propertySupport(),self.animationMap=self._getAnimationMap.init(element),self.screen.style.height="100%",self.screen.style.width="100%",self.screen.style[Modernizr.prefixed("transformStyle")]="preserve-3d",self.canvas.style[Modernizr.prefixed("transformStyle")]="preserve-3d",removeNoJsClass(self),self.manageEvent.init(),self._autoPlay.init(),self._firstRun=!0,self.elementsAnimating=[],id=self.options.startingStepId,id=self._hashTags.init(id),1===self.options.autoPlayDirection?(prevStepId=id-1,self.prevStepId=1>prevStepId?self.noOfSteps:prevStepId):(prevStepId=id+1,self.prevStepId=prevStepId>self.noOfSteps?1:prevStepId),self.currentStepId=self.prevStepId,prevStep="step"+self.prevStepId,self._animationFallback.setupCanvas(id),goToFirstStep=function(){self.options.autoPlay===!0&&self.unpaused(self),self._animation.domDelay(function(){self._animation.resetInheritedSpeed(prevStep,"animate-out")}),self.goTo(id,self.options.autoPlayDirection,!0)},self.options.preloader!==!1?self._preload.init(function(){goToFirstStep(),self._animation.domDelay(function(){self.ready(self)})}):(goToFirstStep(),self._animation.domDelay(function(){self.ready(self)}))},self.destroy=function(){var eventList,eventType,theEvents,i,step,lastStep;clearTimeout(self.autoPlayTimer),clearTimeout(self.phaseThresholdTimer),eventList=self.manageEvent.list;for(eventType in eventList)eventList.hasOwnProperty(eventType)===!0&&(theEvents=eventList[eventType],self.manageEvent.remove(eventType));for(removeClass(self.currentPaginationLink,"sequence-current"),removeClass(self.container,"paused"),removeClass(self.container,"step"+self.currentStepId),self.screen.removeAttribute("style"),self.canvas.removeAttribute("style"),i=0;i<self.noOfSteps;i++)step=self.steps[i],step.removeAttribute("style"),self._animation.resetInheritedSpeed("step"+(i+1),"animate-out"),removeClass(step,"animate-in"),removeClass(step,"animate-out");lastStep=self.steps[self.options.startingStepId-1],self._animation.resetInheritedSpeed("step"+self.options.startingStepId,"animate-in"),addClass(lastStep,"animate-in"),element.dataset.sequence=!1,self.destroyed(self),self={}},self.next=function(){var nextStepId=self.currentStepId+1;nextStepId>self.noOfSteps&&self.options.cycle===!0&&(nextStepId=1),self.goTo(nextStepId)},self.prev=function(){var prevStepId=self.currentStepId-1;1>prevStepId&&self.options.cycle===!0&&(prevStepId=self.noOfSteps),self.goTo(prevStepId)},self.togglePause=function(){self.isPaused===!1?self.pause():self.unpause()},self.pause=function(){self.isHardPaused=!0,self._autoPlay.pause()},self.unpause=function(){self.isHardPaused=!1,self._autoPlay.unpause()},self.goTo=function(id,direction,ignorePhaseThreshold,hashTagNav){if(direction=self._animation.getDirection(id,direction),void 0===id||1>id||id>self.noOfSteps||id===self.currentStepId||self.options.navigationSkip===!1&&self.isActive===!0||self.options.navigationSkip===!0&&self.navigationSkipThresholdActive===!0&&void 0===hashTagNav||self.options.preventReverseSkipping===!0&&self.direction!==direction&&self.isActive===!0)return!1;var phaseThreshold=0;self.direction=direction,void 0===ignorePhaseThreshold&&(phaseThreshold=self.options.phaseThreshold);var currentStep="step"+self.currentStepId,nextStep="step"+id,currentStepElement=self.animationMap[currentStep].element,nextStepElement=self.animationMap[nextStep].element;if(self._animation.moveActiveStepToTop(currentStepElement,nextStepElement),self._animation.manageNavigationSkip(id,direction,currentStep,nextStep,nextStepElement),self.isActive=!0,self._animation.changeStep(id),self.transitionsSupported===!0){self._canvas.move(id,!0),self._animation.resetInheritedSpeed(nextStep,"animate-out");var stepDurations=self._animation.getStepDurations(id,nextStep,currentStep,direction);1===direction?self._animation.forward(id,nextStep,nextStepElement,currentStep,currentStepElement,stepDurations,hashTagNav):self._animation.reverse(id,nextStep,nextStepElement,currentStep,currentStepElement,stepDurations,hashTagNav)}else self._animationFallback.goTo(id,currentStep,currentStepElement,nextStep,nextStepElement,direction,hashTagNav)},self.paused=function(){},self.unpaused=function(){},self.animationStarted=function(){},self.animationFinished=function(){},self.currentPhaseStarted=function(){},self.currentPhaseEnded=function(){},self.nextPhaseStarted=function(){},self.nextPhaseEnded=function(){},self.throttledResize=function(){},self.preloaded=function(){},self.preloadProgress=function(){},self.ready=function(){},self.destroyed=function(){},self._init(element),self}};return Sequence}sequence=defineSequence(imagesLoaded,Hammer);
//# sourceMappingURL=sequence.min.map